/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.ui;////引入ui包

import android.accounts.Account;//引入ui包//该类主要实现的是对背景颜色和字体大小的数据储存， 继承了PreferenceActivity主要功能为对系统信息和配置进行自动保存的Activity
import android.accounts.AccountManager;
import android.app.ActionBar;
import android.app.AlertDialog;
import android.content.BroadcastReceiver;
import android.content.ContentValues;
import android.content.Context;//文本
import android.content.DialogInterface;//对话
import android.content.Intent;
import android.content.IntentFilter;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceClickListener;
import android.preference.PreferenceActivity;
import android.preference.PreferenceCategory;//继承PreferenceActivity，主要功能为对系统配置进行自动保存以及实现用户同步的操作
import android.text.TextUtils;
import android.text.format.DateFormat;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;//按钮
import android.widget.TextView;
import android.widget.Toast;

import net.micode.notes.R;
import net.micode.notes.data.Notes;//引入R包
import net.micode.notes.data.Notes.NoteColumns;
import net.micode.notes.gtask.remote.GTaskSyncService;


public class NotesPreferenceActivity extends PreferenceActivity {//类：NotesPreferenceActivity，在小米便签中主要实现的是对背景颜色和字体大小的数据储存。
    继承了PreferenceActivity主要功能为对系统信息和配置进行自动保存的Activity
    public static final String PREFERENCE_NAME = "notes_preferences";//NotesPreferenceActivity，在小米便签中主要实现的是对背景颜色和字体大小的数据储存。继承了PreferenceActivity主要功能为对系统信息和配置进行自动保存的Activity

    public static final String PREFERENCE_SYNC_ACCOUNT_NAME = "pref_key_account_name";//同步账户名

    public static final String PREFERENCE_LAST_SYNC_TIME = "pref_last_sync_time";//最后同步时间

    public static final String PREFERENCE_SET_BG_COLOR_KEY = "pref_key_bg_random_appear";//设置颜色按键

    private static final String PREFERENCE_SYNC_ACCOUNT_KEY = "pref_sync_account_key";//账户同步密码

    private static final String AUTHORITIES_FILTER_KEY = "authorities";//本地密码

    private PreferenceCategory mAccountCategory;

    private GTaskReceiver mReceiver;

    private Account[] mOriAccounts;

    private boolean mHasAddedAccount;

    @Override
    protected void onCreate(Bundle icicle) {//新建Activity
        super.onCreate(icicle);//执行父类创建函数

        /* using the app icon for navigation */
        getActionBar().setDisplayHomeAsUpEnabled(true);//给左上角图标的左边加上一个返回的图标

        addPreferencesFromResource(R.xml.preferences);//给左上角图标的左边加上一个返回的图标
        mAccountCategory = (PreferenceCategory) findPreference(PREFERENCE_SYNC_ACCOUNT_KEY);//添加xml来源并显示 xml
        mReceiver = new GTaskReceiver();//根据同步账户关键码来初始化分组
        IntentFilter filter = new IntentFilter();//设置过滤项
        filter.addAction(GTaskSyncService.GTASK_SERVICE_BROADCAST_NAME);
        registerReceiver(mReceiver, filter);

        mOriAccounts = null;
        View header = LayoutInflater.from(this).inflate(R.layout.settings_header, null);
        getListView().addHeaderView(header, null, true);
    }

    @Override
    protected void onResume() {//函数功能：activity交互功能的实现，用于接受用户的输入
        super.onResume();//函数功能：activity交互功能的实现，用于接受用户的输入

        // need to set sync account automatically if user has added a new
        // account
        if (mHasAddedAccount) {//代码块：若用户新加了账户则自动设置同步账户
            Account[] accounts = getGoogleAccounts();//获取google账户
            if (mOriAccounts != null && accounts.length > mOriAccounts.length) {
                for (Account accountNew : accounts) {//遍历账户
                    boolean found = false;//更新账户
                    for (Account accountOld : mOriAccounts) {//循环判断当前账户列表中的账户是否与新建账户名相同
                        if (TextUtils.equals(accountOld.name, accountNew.name)) {//若没找到旧账户则只设置新账户为同步账户
                            found = true;// 语句：更新账户
                            break;
                        }
                    }
                    if (!found) {
                        setSyncAccount(accountNew.name);
                        break;
                    }
                }
            }
        }

        refreshUI();
    }

    @Override
    protected void onDestroy() {//销毁Activity
        if (mReceiver != null) {//销毁接收器
            unregisterReceiver(mReceiver);//语句：注销接收器
        }
        super.onDestroy();//语句：执行销毁动作
    }

    private void loadAccountPreference() {//设置账户信息
        mAccountCategory.removeAll();//移除所有分组

        Preference accountPref = new Preference(this);//销毁所有的分组
        final String defaultAccount = getSyncAccountName(this);//建立首选项
        accountPref.setTitle(getString(R.string.preferences_account_title));//首选项的大小标题
        accountPref.setSummary(getString(R.string.preferences_account_summary));//类似title的副标题
        accountPref.setOnPreferenceClickListener(new OnPreferenceClickListener() {
            public boolean onPreferenceClick(Preference preference) {//设置首选项的大标题和小标题
                if (!GTaskSyncService.isSyncing()) {//不处于同步状态
                    if (TextUtils.isEmpty(defaultAccount)) {
                        // the first time to set account
                        showSelectAccountAlertDialog();
                    } else {//代码块：若是账户已经存在，则显示修改对话框并进行修改操作
                        // if the account has already been set, we need to promp
                        // user about the risk
                        showChangeAccountConfirmAlertDialog();//已有账户则显示确认对话框
                    }
                } else {//代码块：若在没有同步的情况下，则在toast中显示不能修改
                    Toast.makeText(NotesPreferenceActivity.this,//若正在同步则显示不能修改账户
                            R.string.preferences_toast_cannot_change_account, Toast.LENGTH_SHORT)
                            .show();
                }
                return true;
            }
        });

        mAccountCategory.addPreference(accountPref);//语句：根据新建首选项编辑新的账户分组
    }

    private void loadSyncButton() {//设置同步按键和最近同步时间
        Button syncButton = (Button) findViewById(R.id.preference_sync_button);
        TextView lastSyncTimeView = (TextView) findViewById(R.id.prefenerece_sync_status_textview);//获取同步按钮控件和最终同步时间的的窗口

        // set button state
        if (GTaskSyncService.isSyncing()) {
            syncButton.setText(getString(R.string.preferences_button_sync_cancel));
            syncButton.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {//设置点击监听器
                    GTaskSyncService.cancelSync(NotesPreferenceActivity.this);
                }
            });
        } else {//非同步状态下按键显示“立即同步”，设置相关监听器
            syncButton.setText(getString(R.string.preferences_button_sync_immediately));//若是不同步则设置按钮显示的文本为“立即同步”以及对应监听器
            syncButton.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {//若是不同步则设置按钮显示的文本为“立即同步”以及对应监听器
                    GTaskSyncService.startSync(NotesPreferenceActivity.this);//点击行为
                }
            });
        }
        syncButton.setEnabled(!TextUtils.isEmpty(getSyncAccountName(this)));//语句：若是不同步则设置按钮显示的文本为“立即同步”以及对应监听器
        设置按键可用还是不可用

        // set last sync time
        if (GTaskSyncService.isSyncing()) {//设置按键的可用性
            lastSyncTimeView.setText(GTaskSyncService.getProgressString());
            lastSyncTimeView.setVisibility(View.VISIBLE);
        } else {//根据当前同步服务器设置时间显示框的文本以及可见性
            long lastSyncTime = getLastSyncTime(this);
            if (lastSyncTime != 0) {//设置一些显示的内容
                lastSyncTimeView.setText(getString(R.string.preferences_last_sync_time,//非同步时，若最近同步时间不为0则显示最近同步时间
                        DateFormat.format(getString(R.string.preferences_last_sync_time_format),
                                lastSyncTime)));
                lastSyncTimeView.setVisibility(View.VISIBLE);
            } else {//根据最后同步时间的信息来编辑时间显示框的文本内容和可见性
                lastSyncTimeView.setVisibility(View.GONE);//最近同步时间为空设置同步时间不可见
            }
        }
    }

    private void refreshUI() {// 函数:刷新标签界面
        loadAccountPreference();
        loadSyncButton();
    }

    private void showSelectAccountAlertDialog() {//函数：显示账户选择的对话框并进行账户的设置
        AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(this);//语句：创建一个新的对话框

        View titleView = LayoutInflater.from(this).inflate(R.layout.account_dialog_title, null);
        TextView titleTextView = (TextView) titleView.findViewById(R.id.account_dialog_title);
        titleTextView.setText(getString(R.string.preferences_dialog_select_account_title));
        TextView subtitleTextView = (TextView) titleView.findViewById(R.id.account_dialog_subtitle);//文本试图设置
        subtitleTextView.setText(getString(R.string.preferences_dialog_select_account_tips));

        dialogBuilder.setCustomTitle(titleView);//代码块：设置标题以及子标题的内容
        dialogBuilder.setPositiveButton(null, null);

        Account[] accounts = getGoogleAccounts();//获得谷歌账户
        String defAccount = getSyncAccountName(this);

        mOriAccounts = accounts;//语句：获取同步账户信息
        mHasAddedAccount = false;

        if (accounts.length > 0) {//语句：若账户不为空
            CharSequence[] items = new CharSequence[accounts.length];
            final CharSequence[] itemMapping = items;
            int checkedItem = -1;
            int index = 0;
            for (Account account : accounts) {//通过循环检查账户列表
                if (TextUtils.equals(account.name, defAccount)) {
                    checkedItem = index;
                }
                items[index++] = account.name;
            }
            dialogBuilder.setSingleChoiceItems(items, checkedItem,//语句：在对话框建立一个单选的复选框
                    new DialogInterface.OnClickListener() {
                        public void onClick(DialogInterface dialog, int which) {
                            setSyncAccount(itemMapping[which].toString());//点击则开始设置同步账户
                            dialog.dismiss();//语句：取消对话框
                            refreshUI();//刷新界面
                        }
                    });
        }

        View addAccountView = LayoutInflater.from(this).inflate(R.layout.add_account_text, null);//视图，添加新的账户
        dialogBuilder.setView(addAccountView);//语句：给新加账户对话框设置自定义样式

        final AlertDialog dialog = dialogBuilder.show();//语句：显示对话框
        addAccountView.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {//设置监听器
                mHasAddedAccount = true;//功能描述：响应点击添加账户的请求
                函数实现：除了调用父类的onCreate，还有一些自己的个性化配置
                参数描述：
                @v 视图，包括很多设置参数
                Intent intent = new Intent("android.settings.ADD_ACCOUNT_SETTINGS");//语句：建立网络建立组件
                intent.putExtra(AUTHORITIES_FILTER_KEY, new String[] {
                    "gmail-ls"
                });
                startActivityForResult(intent, -1);
                dialog.dismiss();
            }
        });
    }

    private void showChangeAccountConfirmAlertDialog() {//刷新标签界面
        AlertDialog.Builder dialogBuilder = new AlertDialog.Builder(this);//语句：创建一个新的对话框

        View titleView = LayoutInflater.from(this).inflate(R.layout.account_dialog_title, null);
        TextView titleTextView = (TextView) titleView.findViewById(R.id.account_dialog_title);
        titleTextView.setText(getString(R.string.preferences_dialog_change_account_title,
                getSyncAccountName(this)));
        TextView subtitleTextView = (TextView) titleView.findViewById(R.id.account_dialog_subtitle);
        subtitleTextView.setText(getString(R.string.preferences_dialog_change_account_warn_msg));//语句：根据同步修改的账户信息设置标题以及子标题的内容
        dialogBuilder.setCustomTitle(titleView);

        CharSequence[] menuItemArray = new CharSequence[] {//代码块：设置对话框的自定义标题
                getString(R.string.preferences_menu_change_account),
                getString(R.string.preferences_menu_remove_account),
                getString(R.string.preferences_menu_cancel)
        };
        dialogBuilder.setItems(menuItemArray, new DialogInterface.OnClickListener() {
            public void onClick(DialogInterface dialog, int which) {
                if (which == 0) {//语句：进入账户选择对话框
                    showSelectAccountAlertDialog();//显示账户选择提示对话框
                } else if (which == 1) {//删除同步账户
                    removeSyncAccount();//语句：删除账户并且跟新便签界面
                    refreshUI();
                }
            }
        });
        dialogBuilder.show();//语句：显示对话框
    }

    private Account[] getGoogleAccounts() {//函数：获取谷歌账户，可通过账户管理器直接获取
        AccountManager accountManager = AccountManager.get(this);
        return accountManager.getAccountsByType("com.google");
    }

    private void setSyncAccount(String account) {//函数：设置同步账户
        if (!getSyncAccountName(this).equals(account)) {//代码块：如果该账号不在同步账号列表中
            SharedPreferences settings = getSharedPreferences(PREFERENCE_NAME, Context.MODE_PRIVATE);
            SharedPreferences.Editor editor = settings.edit();//编辑共享首选项
            if (account != null) {//语句：编辑共享的首选项
                editor.putString(PREFERENCE_SYNC_ACCOUNT_NAME, account);
            } else {
                editor.putString(PREFERENCE_SYNC_ACCOUNT_NAME, "");
            }
            editor.commit();

            // clean up last sync time
            setLastSyncTime(this, 0);// 语句：将最后同步时间清零

            // clean up local gtask related info
            new Thread(new Runnable() {
                public void run() {//新线程的创建
                    ContentValues values = new ContentValues();
                    values.put(NoteColumns.GTASK_ID, "");
                    values.put(NoteColumns.SYNC_ID, 0);
                    getContentResolver().update(Notes.CONTENT_NOTE_URI, values, null, null);
                }
            }).start();//代码块：重置当地同步任务的信息

            Toast.makeText(NotesPreferenceActivity.this,//设置一个toast提示信息，提示用户成功设置同步
                    getString(R.string.preferences_toast_success_set_accout, account),
                    Toast.LENGTH_SHORT).show();
        }
    }

    private void removeSyncAccount() {//函数：删除同步账户
        SharedPreferences settings = getSharedPreferences(PREFERENCE_NAME, Context.MODE_PRIVATE);//SharedPreferences是以键值对的形式存储数据的，其使用非常简单，能够轻松的存放数据和读取数据
        SharedPreferences.Editor editor = settings.edit();//语句：设置共享首选项
        if (settings.contains(PREFERENCE_SYNC_ACCOUNT_NAME)) {//代码块：假如当前首选项中有账户就删除
            editor.remove(PREFERENCE_SYNC_ACCOUNT_NAME);
        }
        if (settings.contains(PREFERENCE_LAST_SYNC_TIME)) {//代码块：删除当前首选项中有账户时间
            editor.remove(PREFERENCE_LAST_SYNC_TIME);
        }
        editor.commit();

        // clean up local gtask related info
        new Thread(new Runnable() {
            public void run() {//新线程
                ContentValues values = new ContentValues();
                values.put(NoteColumns.GTASK_ID, "");
                values.put(NoteColumns.SYNC_ID, 0);
                getContentResolver().update(Notes.CONTENT_NOTE_URI, values, null, null);
            }
        }).start();
    }

    public static String getSyncAccountName(Context context) {//函数：获取同步账户名称
        通过共享的首选项里的信息直接获取
        SharedPreferences settings = context.getSharedPreferences(PREFERENCE_NAME,//获取同步账户名称
                Context.MODE_PRIVATE);
        return settings.getString(PREFERENCE_SYNC_ACCOUNT_NAME, "");
    }

    public static void setLastSyncTime(Context context, long time) {//设置最终同步的时间
        SharedPreferences settings = context.getSharedPreferences(PREFERENCE_NAME,
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = settings.edit();//语句：从共享首选项中找到相关账户并获取其编辑器
        editor.putLong(PREFERENCE_LAST_SYNC_TIME, time);
        editor.commit();//语句：编辑最终同步时间并提交更新
    }

    public static long getLastSyncTime(Context context) {//函数：获取最终同步时间
        通过共享的首选项里的信息直接获取
        SharedPreferences settings = context.getSharedPreferences(PREFERENCE_NAME,//通过共享，获取时间
                Context.MODE_PRIVATE);
        return settings.getLong(PREFERENCE_LAST_SYNC_TIME, 0);
    }

    private class GTaskReceiver extends BroadcastReceiver {//函数：接受同步信息

        @Override
        public void onReceive(Context context, Intent intent) //功能描述：响应接收广播的情况
        函数实现：刷新界面，判断是否同步状态下
        参数描述：
        @intent携带了活动的数据，
        @context是有关的内容
            refreshUI();
            if (intent.getBooleanExtra(GTaskSyncService.GTASK_SERVICE_BROADCAST_IS_SYNCING, false)) {// 代码块：获取随广播而来的Intent中的同步服务的数据
                TextView syncStatus = (TextView) findViewById(R.id.prefenerece_sync_status_textview);//通过获取的数据在设置系统的状态
                syncStatus.setText(intent
                        .getStringExtra(GTaskSyncService.GTASK_SERVICE_BROADCAST_PROGRESS_MSG));
            }

        }
    }

    public boolean onOptionsItemSelected(MenuItem item) {//函数：处理菜单的选项
        switch (item.getItemId()) {//代码块：根据选项的id选择，这里只有一个主页
            case android.R.id.home://返回主界面
                Intent intent = new Intent(this, NotesListActivity.class);
                intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
                startActivity(intent);//创建活动
                return true;
            default://代码块：在主页情况下在创建连接组件intent，发出清空的信号并开始一个相应的activity
                return false;
        }
    }
}
